define("io.ox/office/editframework/app/editapplication",["exports","io.ox/core/tk/doc-converter-utils","io.ox/core/api/user","io.ox/core/api/tab","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/forms","io.ox/office/tk/utils/io","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/tk/worker/intervalrunner","io.ox/office/tk/dialogs","io.ox/office/baseframework/utils/apputils","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/baseframework/utils/errorcontextdata","io.ox/office/baseframework/utils/clienterror","io.ox/office/baseframework/utils/infostate","io.ox/office/baseframework/utils/errormessages","io.ox/office/baseframework/utils/infomessages","io.ox/office/baseframework/utils/seleniumlogger","io.ox/office/baseframework/app/baseapplication","io.ox/office/baseframework/app/extensionregistry","io.ox/office/rt2/rt2const","io.ox/office/rt2/rt2protocol","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/utils/webfonts","io.ox/office/editframework/utils/dateutils","io.ox/office/editframework/app/rtconnection","io.ox/office/editframework/app/rtconnectionviewer","io.ox/office/editframework/app/acquireeditrightsworker","io.ox/office/editframework/view/editlabels","gettext!io.ox/office/editframework/main"],function(e,Yt,zt,Kt,Qt,t,n,Zt,r,i,Jt,Xt,o,a,s,en,tn,nn,rn,on,an,sn,ln,l,cn,dn,un,gn,pn,c,d,fn,En,hn,u,On,_n){"use strict";var Sn=t.isFiniteNumber,mn=t.getNumber,In=t.getArray,g=t.newDeferred,Rn=t.newFulfilled,Nn=t.newRejected,An=t.toPromise,Dn=n.stringEndsWith,vn=n.trimAndCleanString,yn=n.capitalizeFirst,bn=n.filterArray,Cn=r.FILTER_MODULE_NAME,Tn=r.requireOptModule,wn=i.globalLogger,Fn=i.getFormattedLogBuffer,Ln=gn.SaveAsType,Un=gn.STORAGE_AVAILABLE,xn=gn.RENAME_DISABLED,kn=gn.TRANSFER_EDIT_RIGHTS_TIMEOUT,$n=o.IntervalRunner,Pn=a.MessageDialog,Mn=s.FlushReason,Bn=s.QuitReason,Hn=l.BaseApplication,Gn=c.otLogger,qn=c.dbgDumpActions,jn=d.importWebFonts,Vn=u.acquireEditLogger,Wn=u.AcquireEditRightsWorker,Yn="accept",zn="decline",Kn="inactive",Qn=_n("unnamed"),Zn=["editUserId","editUser","hasErrors","writeProtected","activeUsers","locked","lockedByUser","lockedByUserId","failSafeSaveDone","serverOSN"];function Jn(e){var t=In(e,"operations",!0);return t.every(_.isObject)?t:(wn.error("$badge{EditApp} getOperationsFromData: invalid elements in operations array",t),[])}function Xn(e){if(_.isObject(e)&&_.isString(e.action))switch(e.action){case"reload":e.action={itemKey:"document/reload",icon:On.RELOAD_ICON,label:On.RELOAD_LABEL};break;case"acquireedit":e.action={itemKey:"document/acquireeditOrPending",icon:On.EDIT_ICON,label:On.EDIT_LABEL};break;case"loadrestored":e.action={itemKey:"document/reload",icon:On.LOAD_RESTORED_ICON,label:On.LOAD_RESTORED_LABEL};break;default:delete e.action}}function er(e,t,n){var r=g();e.done(function(e){r.resolve(e)}),e.fail(function(e){r.reject(e)});var i=window.setTimeout(function(){r.reject("timeout"),wn.warn(n+" - operation timed out")},t);return e.always(function(){window.clearTimeout(i)}),r.promise()}e.EditApplication=Hn.extend(function(e,w,F){var L=this,U=null,x=null,t=null,k=null,n=null,P=null,M=null,p=[],i=null,r=!1,o=!1,a=0,B=Qt.getFunctionOption(F,"preProcessHandler"),H=Qt.getFunctionOption(F,"postProcessHandler"),f=Qt.getFunctionOption(F,"fastEmptyLoadHandler"),E=Qt.getFunctionOption(F,"previewHandler"),s=Qt.getFunctionOption(F,"importFailedHandler",_.noop),l=Qt.getFunctionOption(F,"optimizeOperationsHandler"),c=!0,h=Qt.getFunctionOption(F,"mergeCachedOperationsHandler"),O=!F||!F.otConfigKey||gn.getFlag(F.otConfigKey,!0),d=O?100:Qt.getNumberOption(F,"sendActionsDelay",0),u=Qt.getBooleanOption(F,"isMultiSelectionApp",!0),g=Qt.getBooleanOption(F,"isSnapshotApp",!0),S=null,m=null,I=!1,R=null,N=null,A=!1,D=!1,v=null,y=!1,b=!1,G=!1,C=null,T=!1,q=!1,j=!1,V=null,W=!1,Y=Qt.getBooleanOption(F,"localStorageApp",!1)&&!O,z=Qt.getIntegerOption(F,"requiredStorageVersion",0),K=Qt.getIntegerOption(F,"supportedStorageVersion",0),Q=!1,Z=gn.USE_LOCAL_STORAGE&&!0===ox.secretCookie&&!w.auth_code,J=!1,X={},ee=1,te=[],ne=[],re=[],ie=null,oe=0,ae=!1,se=Qt.getBooleanOption(F,"supportsOnlineSync",!0),le=null,ce=!1,de=!1,ue={},ge="",pe={},fe=[],Ee=!0,he=!1,Oe=[],_e=null,Se=null,me=!1,Ie=!1,Re=!1,Ne=null,Ae=null,De=0,ve=!0,ye=null,be=null,Ce=!1,Te="slow load",we=!1,Fe=[],Le=0,Ue=null,xe=-1,ke=0,$e=[],Pe={},Me=null,Be=null,He=!1,Ge=!1;function qe(e,t){var n=L.getState();L.setRootAttribute("data-app-state",n),L.trigger("docs:state",n,e,t),L.trigger("docs:state:"+n,t),Vn.log("statechange",n,e)}function je(e){var t=T?"error":ie?"preview":I?G||!N?"readonly":yt()?"sending":A?"ready":"initial":"offline";if(S!==t){var n=S;S=t,qe(n,e)}}function Ve(e){N!==e&&(N=e,L.trigger("docs:editmode",N),Vn.log("$back{LightPink}changeEditMode",N),L.trigger(N?"docs:editmode:enter":"docs:editmode:leave"),je())}function We(){return{documentFileLockedByUser:C,fullFileName:L.getFullFileName(),oldEditUser:R,isEditor:ht()}}function Ye(e,t){var n=_n("Read-Only Mode"),r=null,i=null,o=null;_.isString(e)?(i={type:"info",message:e,headline:n},isNaN(t)||(i.duration=t),i=_.extend({},i,{action:"acquireedit"})):(o=We(),r=L.getErrorState(),i=ye,_.isObject(i)||(_.isObject(r)&&(r.isError()||r.isWarning())?i=an.getMessageData(r,o):(r=L.getInfoState(),_.isString(r)&&(i=sn.getMessageData(r,o))))),L.extendMessageData(i),x.yell(i)}Hn.call(this,e,function(){var l=[],N=L.createDeferred("EditApplication.asynchronousLoadFinished"),e=null,t=null,c=$.Deferred(),d=!1,u=!1,A=[],D=[],v=!1,o=-1,g=L.launchTracker;function y(e,t){A.push(t),En.log("Document status update received during document import")}function b(e,t){D.push(t),En.log("Clients update received during document import")}function C(e,t){En.log("Final operation message received for asynchronous load"),O&&!L.isViewerMode()&&St(t.docStatus.serverOSN),t.hasErrors||"error"===L.getState()?N.reject(t):c.always(function(){var e,n,r,i;l.push(t),N.resolve((e=l,n={},r=[],i=null,_.each(e,function(e){var t=e.operations;$.extend(n,e),t&&(delete e.operations,r=r.concat(t)),e.rescueOperations&&(i=e.rescueOperations)}),Pe=n&&n.syncInfo,En.log("loadDocInfo",Pe),n.operations=r,i&&(n.rescueOperations=i),_.isEmpty(n.operations)&&n.syncInfo&&o===parseInt(n.syncInfo["document-osn"],10)&&(v=!0),n))})}function T(e,t){var n,r,i,o,a=null;if(ae)return delete t.actions,0<l.length?l[0]=_.extend(l[0],t):l.push(t),void c.resolve();if(n=t,Qt.getBooleanOption(n,"preview",!1))return d=!0,void l.push(t);if(d&&!u){u=!0,r=l,i=0,o=[],_.each(r,function(e){i=_.isNumber(e.activeSheet)?e.activeSheet:i,o=o.concat(e.operations)}),a={preview:{activeSheet:i,operations:o}},(l=[]).push(t);var s=function(n){var e=new en(n),r=Qt.getObjectOption(n,"preview"),t=e.isError()?$.Deferred().reject(n):$.when();r&&_.isArray(r.operations)&&(t=function(){var e=Nt(B,"previewPreProcessing","Preview preprocess handler finished");return e=e.then(function(){B=null;var e=In(n.preview,"operations"),t=e?U.applyExternalOperations(e,{expand:!0}):L.createResolvedPromise();return g.asyncStep(t,"previewApplyOperations","$badge{EditApp} "+(e?e.length:0)+" preview operations applied"),t=t.then(function(){return E.call(L,r)?L.leaveBusyDuringImport():$.when()},function(e){e&&"abort"===e||(n.operationError=!0,n.message=_n("An unrecoverable error occurred while modifying the document."))})}),g.asyncStep(e,"previewEnd","$badge{EditApp} Preview postprocess handler finished")}());return t}(a);return g.asyncStep(s,"previewProcessing","$badge{EditApp} Preview data processed"),s.done(function(){c.resolve()}),void s.fail(function(){c.reject(),At(t)})}d||"pending"!==c.state()||c.resolve(),l.push(t)}function r(t){var n,r,e,i,o,a,s,l,c,d,u,g,p,f,E=Jn(t),h=(n=t.docStatus,r={},Zn.forEach(function(e){e in n&&(r[e]=n[e])}),r),O=new en(t),S=null;function m(e,t){return He=!!e.rescueOperations||Qt.getBooleanOption(e.docStatus,"rescueDoc",null),Ot(e).always(function(){pt(e.docStatus)}),Se=Qt.getStringOption(e.syncInfo,"restore_id",null),Q=Qt.getBooleanOption(e.syncInfo,"renameNeedsReload",!1),L.waitForImportSuccess(function(){En.log("Applying clients update messages, count = "+D.length),_.each(D,function(e){Ot(e)}),En.log("Applying document update messages, count = "+t.length),_.each(t,function(e){Rt(e)}),kt()&&(M.off(un.RESPONSE_OPEN_DOC_CHUNK,T),M.off(un.RESPONSE_OPEN_DOC,C),M.off(un.BROADCAST_UPDATE_CLIENTS,b).on(un.BROADCAST_UPDATE_CLIENTS,function(e,t){Ot(t)}),M.off(un.BROADCAST_UPDATE,y).on(un.BROADCAST_UPDATE,function(e,t){Rt(t)})),je(),gn.DEBUG&&e.rescueOperations&&L.trigger("docs:rescueoperations",e.rescueOperations),N.resolve({action:[]})}),$.when()}function I(){return L.getUserInfo(ox.user_id).done(function(e){P=Qt.escapeHTML(e.operationName)})}if(L.isViewerMode()&&(G=!0,Ve(!(Pe={}))),k=Qt.getStringOption(t.docStatus,"clientId",""),X[k]=0,e=null,Qt.getBooleanOption(t,"hasErrors",!1)?(wn.error("$badge{EditApp} importHandler: server side error"),e="server"):Qt.getBooleanOption(t,"operationError",!1)?(wn.error("$badge{EditApp} importHandler: operation failure"),e=t.message):O.isError()?(wn.error("$badge{EditApp} importHandler: server side error, errorCode="+O.getCodeAsConstant()),e="server"):0===k.length?(wn.error("$badge{EditApp} importHandler: missing client identifier"),e="noclientid"):ae||v||_.isArray(E)&&0!==E.length||(wn.error("$badge{EditApp} importHandler: missing document operations"),e="noactions"),S=e?{cause:e}:null,_.isObject(S))return S=_.extend(S,At(t)),$.Deferred().reject(S);if(i=!0,s=0,u=d=c=l=a=o=null,"load"===w.action&&_.isObject(w.file)&&(Un&&Y&&Z&&t.syncInfo&&t.syncInfo.fileVersion&&Sn(t.syncInfo["document-osn"])&&t.syncInfo.fileId&&t.syncInfo.folderId&&_.isFunction(U.setFullModelNode)&&_.isFunction(U.getSupportedStorageExtensions)&&(o=t.syncInfo.fileId+"_"+t.syncInfo.folderId,d=o+"_FILEVERSION",a=o+"_STORAGEVERSION",l=o+"_OSN",c=o+"_OPERATIONS",u=U.getSupportedStorageExtensions(),s=localStorage.getItem(a)&&parseInt(localStorage.getItem(a),10)||1,z<=s?(wn.info("$badge{EditApp} importHandler: document-osn="+t.syncInfo["document-osn"]+", document-rev="+t.syncInfo.fileVersion),localStorage.getItem(d)&&localStorage.getItem(d)===t.syncInfo.fileVersion&&localStorage.getItem(l)&&parseInt(localStorage.getItem(l),10)===parseInt(t.syncInfo["document-osn"],10)?function(){var e=JSON.parse(localStorage.getItem(c));if(_.isArray(e)){0<E.length&&U.setExternalLocalStorageOperationsExist(!0),E=e.concat(E);var t=_.last(E);return _.isNumber(t.osn)||(t.opl=1,t.osn=parseInt(localStorage.getItem(l),10)-1),1}}()?u.some(function(e){var t=o+e.extension,n={usedLocalStorage:!0};_.isObject(e.additionalOptions)&&_.extend(n,e.additionalOptions);var r=localStorage.getItem(t);if(r)wn.info("$badge{EditApp} importHandler: loading document from local storage. Key: "+t+" Length: "+localStorage.getItem(t).length),J=!0,Te="local storage",U.setFullModelNode(r,n);else{if(!e.optional)return wn.info("$badge{EditApp} importHandler: key in local storage not found. Key: "+t+". But found OSN key: "+l),R(),!(J=!1);wn.info("$badge{EditApp} importHandler: optional local storage value not found. Key: "+t)}}):(wn.info("$badge{EditApp} importHandler: required operations in local storage not found. Key: "+c),R()):(wn.info("$badge{EditApp} importHandler: file in local storage not found. Key: "+o),R())):(wn.info("$badge{EditApp} importHandler: version of file in local storage not supported. Key: "+o),R())),J&&U.trigger("update:model",{usedLocalStorage:!0})),!i)return $.Deferred().reject({cause:"localStorageFailed",headline:_.noI18n("LocalStorage failure")});function R(){_.each(u,function(e){localStorage.removeItem(o+e.extension)}),localStorage.removeItem(l),localStorage.removeItem(a),localStorage.removeItem(d),localStorage.removeItem(c)}return g=null,p="",f=Qt.getBooleanOption(t,"fastLoad",!1),J||(!t.htmlDoc&&gn.DEBUG&&!ae&&U.setFullModelNode&&f&&L.getFileDescriptor()&&!Dn(L.getFileDescriptor().filename,"_ox")&&x.yell({type:"error",headline:_.noI18n("Error in fastload"),message:_.noI18n('you should have a look in the backend logfiles ("Exception while creating the generic html document")')}),t.htmlDoc&&_.isFunction(U.setFullModelNode)&&!ae&&(wn.info("$badge{EditApp} importHandler: load complete HTML document, osn: ",t.syncInfo["document-osn"]),(g=JSON.parse(t.htmlDoc)).mainDocument&&U.setFullModelNode(g.mainDocument),g.headerFooter&&(_.each(g.headerFooter,function(e){p+=e}),U.setFullModelNode(p,{headerFooterLayer:!0}),U.getPageLayout().headerFooterCollectionUpdate()),g.comments&&(p="",_.each(g.comments,function(e){p+=e}),U.setFullModelNode(p,{commentLayer:!0})),Te="fast load",U.trigger("fastload:done"))),A.unshift({docStatus:h}),ae?(Te="fast empty",m(t,A).then(I)):Nt(B,"preProcessing","Import preprocess handler finished").then(I).then(function(){var e=Nt(function(){var e=F&&F.applyActionsDetached;return e&&x.detachAppPane(),U.applyExternalOperations(E,{expand:!0}).always(function(){e&&x&&!x.destroyed&&x.attachAppPane()})},"applyOperations",E.length+" document operations applied");return e=e.then(function(){if(U.getOperationStateNumber()<0)return $.Deferred().reject({cause:"applyactions",headline:_n("Synchronization Error")});var e=J&&!U.externalLocalStorageOperationsExist();return Nt(H?H.bind(L,e):null,"postProcessing","Import postprocess handler finished").then(function(){return m(t,A)},function(e){return _.extend({cause:"postprocess"},e)})},function(e){if(kt()&&M.off(un.RESPONSE_OPEN_DOC,C),"destroy"!==e)throw _.extend({cause:"applyactions"},e)})},function(e){throw _.extend({cause:"preprocess"},e)})}U.undoManager.on("undogroup:open",function(){i=Dt()}),U.undoManager.on("undogroup:close",function(){vt()&&Ft(i),i=null,U.setInternalOperationBlocker(!1)}),U.on("operations:success",function(e,t,n,r){n||he||(_.isObject(i)?(En.log("operations:success - push operations into pending action"),i.operations=i.operations.concat(t),r&&(i.userData=r)):Ft(Dt(t,r)))}),U.on("cacheBuffer:flush",function(){En.log("cacheBuffer:flush received - send cached operations"),_.isFunction(h)&&Oe.length&&(p=h.call(L,p,Oe),wt())}),U.on("operations:error",function(){L.isImportFinished()?(L.setInternalError(rn.ERROR_WHILE_MODIFYING_DOCUMENT,tn.GENERAL),En.error("An unrecoverable error occurred while modifying the document")):(L.setInternalError(rn.ERROR_WHILE_LOADING_DOCUMENT,tn.GENERAL),En.error("An unrecoverable error occurred while loading the document"),N.reject())}),L.getWindowNode().on("drop",!1),M=L.isViewerMode()?new hn(L,F):new En(L);this.rtConnection=M,ae||x.enterBusy({skipCancelOnReadOnly:!0,cancelHandler:function(){L.isInQuit()||(Pt(".abortOpen"),Bt(),L.quit())},immediate:!0,topLabel:_.noI18n(L.getFullFileName()),warningLabel:_n("Sorry, your document is very large. It will take some time to be loaded."),warningDelay:1e4});kt()&&(M.on(dn.EVENT_OFFLINE,Xe),M.on(dn.EVENT_ONLINE,et),M.on(dn.EVENT_ERROR,function(e,t){!function(e,t){var n;En.log("Error handler called by RT2 communication layer, cause = "+JSON.stringify(e)),t&&"pending"===t.state()&&t.reject(e);_.isObject(e)&&_.isString(e.error)&&(n=new en(e));L&&("GENERAL_SESSION_INVALID_ERROR"===n.getCodeAsConstant()?function(e){if(Ce)return;var t=Ce=!0;function n(){ox.off("relogin:success",n),ox.off("relogin:fail",r),t=!1,(O?tt:nt)(),Ce=!1}function r(){ox.off("relogin:success",n),ox.off("relogin:fail",r),L.setInternalError(e),Ce=!1}L.setInternalError(rn.WARNING_SESSION_INVALID_DETECTED,tn.CONNECTION),G=!0,Ve(!1),je(),ox.on("relogin:success",n),ox.on("relogin:fail",r),L.executeDelayed(function(){t&&(t=!1,ox.trigger("relogin:required"))},"EditApplication.connectionErrorHandler",5e3)}(n):"GENERAL_DOCUMENT_ALREADY_DISPOSED_ERROR"===n.getCodeAsConstant()?_.isString(le)?(ce=!0,O?ft({cause:"error:disposed"}):Et(0,null,null,{cause:"error:disposed"})):L.setInternalError(n,tn.CONNECTION):"TOO_MANY_CONNECTIONS_ERROR"===n.getCodeAsConstant()?(ce=!0,le=null,L.setInternalError(n,tn.CONNECTION)):L.isLocked()||L.isInQuit()||_.isString(le)?_.isString(le)&&(ce=!0,O?ft({cause:"reset"}):Et(0,null,null,{cause:"reset"})):"HANGUP_INVALID_OPERATIONS_SENT_ERROR"===e.error||"HANGUP_INVALID_OSN_DETECTED_ERROR"===e.error||"GENERAL_OFFLINE_CLIENT_IN_NON_SYNC_STATE"===e.error?L.setInternalError(e,tn.CONNECTION):"HANGUP_NO_EDIT_RIGHTS_ERROR"===e.error?L.restoreDocument(n):(n=rn.ERROR_UNKNOWN_REALTIME_FAILURE,L.setInternalError(e,tn.CONNECTION)))}(t,N)}),M.on(dn.EVENT_NORESPONSE_IN_TIME,rt),M.on(un.BROADCAST_UPDATE,y),M.on(un.BROADCAST_UPDATE_CLIENTS,b),M.on(un.BROADCAST_SHUTDOWN,it),M.on(un.BROADCAST_CRASHED,ot),M.on(un.BROADCAST_RENAMED_RELOAD,ct),M.on(un.BROADCAST_HANGUP,at),M.on(un.BROADCAST_OT_RELOAD,st));return g.step("initImport","$badge{EditApp} Import process initializated"),t=function(){var t=L.createDeferred("EditApplication.establishConnection");return Nt(function(){var e=kt()?M.connect():L.createRejectedPromise();return En.log("Channel UID:",kt()?M.getChannelUID():null),Me=kt()?M.getDocUID():"null",Be=kt()?M.getClientUID():"null",(e=(e=e.then(function(e){var t=new en(e);if(e.hasErrors||t.isError())throw e;return e})).then(function(t){var e=new en(t);if(e.isWarning()&&"ADVISORY_LOCK_SET_WARNING"===e.getCodeAsConstant()){var n=JSON.parse(e.getErrorValue()),r=new Date(n.since),i=fn.format(r,fn.getDateFormat())+" "+fn.format(r,fn.getTimeFormat()),o=_n("Document in use"),a=L.getUserInfo(n.uid).then(function(e){var t=_n("%1$s edits this document since %2$s on %3$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",_n.noI18n(e.displayName),_n.noI18n(i),_n.noI18n(n.hostName));return x.showQueryDialog(o,t)},function(){var e=_n("Another user edits this document since %1$s on %2$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",_n.noI18n(i),_n.noI18n(n.hostName));return x.showQueryDialog(o,e)});return a=a.then(function(){return L.quit(),t},function(e){if("close"===e)throw e;return t=_.extend({advisoryLock:"reset"},t)})}return t})).done(function(e){t.resolve(e)}),e.fail(function(e){t.reject(e)}),t.promise()},"connect","Realtime connection established")}(),ze(),(e=t.then(function(e){var t=new en(e),n={fastEmpty:ae};if(!t.isError())return kt()&&(M.on(un.RESPONSE_OPEN_DOC_CHUNK,T),M.on(un.RESPONSE_OPEN_DOC,C)),w.auth_code&&(n=_.extend({auth_code:w.auth_code},n)),e&&e.advisoryLock&&(n=_.extend({advisoryLock:e.advisoryLock},n)),"new"===w.action&&(n=_.extend({newDoc:!0},n)),ae&&(n=_.extend({fastEmptyOSN:U.getOperationStateNumber()},n)),Un&&!ae&&Z&&(function(e,t){if("load"!==e.action||!_.isObject(e.file))return;var n=e.file.id+"_"+e.file.folder_id,r=n+"_OSN",i=n+"_FILEVERSION",o=n+"_STORAGEVERSION",a=localStorage.getItem(r),s=localStorage.getItem(i);localStorage.getItem(o)>=z&&a&&s&&(a=parseInt(a,10),s=parseInt(s,10),_.isNumber(a)&&_.isNumber(s)&&(t.storageOSN=a,t.storageVersion=s))}(w,n),o=n.storageOSN),kt()&&M.open(n),N.then(r,function(e){return Nn(e)});At(e)}).catch(function(e){return Nn(At(e))})).always(function(){ie=null,je()}),e},w,_.extend({},F,{initHandler:function(){var e=jn();gn.DEBUG&&(e=e.then(function(){return Tn("io.ox/office/debug/common/main",function(e){return e.initializeApp(L)})}));return e},initFileHandler:function(){if(!L||!w)return wn.warn("$badge{EditApp} initFileHandler: called on an already destroyed instance."),$.Deferred().reject();var e={},n=!1,r=L.launchTracker;e.initial_language=ox.language.replace(/_/g,"-"),w.cryptoAction&&(e.cryptoAction=w.cryptoAction);w.decrypt_auth_code&&(e.cryptoAuth=w.decrypt_auth_code,e.encrypted_file=!0);switch(Qt.getStringOption(w,"action","load")){case"load":return Xt.isDriveFile(w.file)?Xt.getFile(w.file).done(function(e){w.file=e}):$.when();case"convert":n=!0;break;case"new":var t=F&&F.prepareNewDocHandler;t&&_.extend(e,t.call(L));break;default:return wn.error("$badge{EditApp} initFileHandler: unsupported launch action"),$.Deferred().reject()}var i=Qt.getObjectOption(w,"templateFile"),o=Qt.getBooleanOption(w,"preserveFileName",!1),a=Qt.getStringOption(w,"target_filename",Qn),s=Qt.getStringOption(w,"target_folder_id",""),l=Qt.getObjectOption(i,"origin");function c(e){return L.setInternalError(e,tn.CREATEDOC),$.Deferred().reject({cause:n?"convert":"create"})}_.extend(e,{action:"createdefaultdocument",document_type:L.appType,target_filename:a,target_folder_id:s,preserve_filename:o,convert:n}),w.template&&_.extend(e,{action:"createfromtemplate",file_id:i.id});_.isObject(i)&&_.extend(e,{file_id:i.id,version:i.version});L.waitForImportSuccess(function(){var e=L.getFileDescriptor(),t=!w.template&&s!==e.folder_id;(w.template?e.converted:n)?L.setCurrentInfoState(t?on.INFO_DOC_CONVERT_STORED_IN_DEFFOLDER:on.INFO_DOC_CONVERTED_AND_STORED):t&&L.setCurrentInfoState(on.INFO_DOC_CREATED_IN_DEFAULTFOLDER)});var d=_.url.hash("fields"),u=_.url.hash("fields-source");(d||u)&&(_.url.hash("fields",null),_.url.hash("fields-source",null),e.fields=d,e.sourcefields=u);var g=L.sendRequest(Cn,e);return g=g.then(function(e){var t=new en(e);return t.isError()?c(t):e},function(){return c()}),r.asyncStep(g,"createNewDocAfterRequest","$badge{EditApp} New file in remote storage created"),(g=(g=g.then(function(t){return Xt.getFile(t.file).then(function(e){return t.file=e,t})})).then(function(e){function t(t,n){var e=L.isPresentationApp()?L.createResolvedPromise():L.leaveBusyDuringImport(!t,{immediateShow:!0});return r.asyncStep(e,"afterLeaveBusyEarly","$badge{EditApp} Busy state after creation of document left"),e.then(function(){if(t)return n;throw n},function(e){throw t?e:n})}return _.isObject(e.file)?(l&&(e.file.origin=l),e.file.source="drive",e.converted&&(e.file.converted=e.converted),(ae=_.isString(e.htmlDoc)&&_.isArray(e.operations)&&0<e.operations.length)&&f?f.call(L,e.htmlDoc,e.operations).then(t.bind(null,!0),t.bind(null,!1)).then(function(){return e}):e):(wn.error("$badge{EditApp} initFileHandler: missing file descriptor"),$.Deferred().reject())})).then(function(e){return e.file})},flushHandler:function(e){if(T)return Nn();var t=Lt(e);e===Mn.QUIT&&t.always(function(){Ve(!1)});return t=t.then(function(){return kt()?M.flushDocument():Nn()})},messageDataHandler:Xn,printOptionsHandler:function(){return kt()?{doc_uid:M.getDocUID(),client_uid:M.getClientUID()}:null}}));var ze=gn.DEBUG?function(){Z=L.getUserSettingsValue("debugUseLocalStorage",Z)&&!L.isDocumentEncrypted()}:$.noop;function Ke(e){var t=_.findWhere(te,{clientUID:e});return t&&t.userName||""}var Qe=gn.LOG_PERFORMANCE_DATA?function(){var i=x.getToolBarTabs(),o=0;i.on("tab:activated",function e(t,n){if(o++,n){var r="tabActivated_"+yn(n);L.launchTracker.step(r,'$badge{EditApp} Toolbar tab "'+n+'" activated')}2===o&&i.off("tab:activated",e)})}:$.noop;function Ze(){function e(){L.getController().update().done(function(){L.launchTracker.step("considerToolbarUIStable","$badge{EditApp} Toolbar is visually stable"),L.isReloading()&&L.setAppReloadDone(L)})}function t(){Re=!0,L.showEditToolbarAtStart()?x.one("edittoolpane:layout:finished",e):x.one("docs:toolpane:unhide",function(){L.executeDelayed(function(){e()},"registerFirstTabActivatedHandler.unhideToolpaneHandler",150)})}L.showEditToolbarAtStart()?x.getToolBarTabs().one("tab:activated",t):L.waitForImportSuccess(t)}function Je(e){var t=en.isErrorCode(e)?e:function(e){var t;switch(e){case"reset":t=new en(rn.ERROR_CONNECTION_RESET_RECEIVED);break;case"timeout":t=new en(rn.ERROR_CONNECTION_TIMEOUT);break;case"notMember":t=new en(rn.ERROR_CONNECTION_NOT_MEMBER);break;default:t=new en(rn.ERROR_UNKNOWN_REALTIME_FAILURE)}return t}(e);if(t.setErrorContext(tn.CONNECTION),kt()){var n=M.hasPendingActions()||L.hasUnsavedChangesOffice();Ve(!(G=!0)),n?O?L.setInternalError(rn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,tn.CONNECTION):L.restoreDocument(t):(w.action="load",delete w.template,L.reloadDocument())}else L.setInternalError(t,tn.CONNECTION)}function Xe(){j=!0,I&&!T&&!L.isInQuit()&&kt()&&(q=N,I=!1,O&&Ue.abort(),le?M.hasPendingActions()?L.setInternalError(rn.ERROR_OFFLINE_WHILE_SYNC_LOCAL_CHANGES,tn.OFFLINE):L.setInternalError(rn.ERROR_OFFLINE_WHILE_SYNCHRONIZING,tn.OFFLINE):(Ve(!(G=!0)),je(),L.setInternalError(rn.WARNING_READONLY_DUE_TO_OFFLINE,tn.OFFLINE)),En.log("Connection offline handler called by Realtime!"),ut())}function et(){!j||I||T||L.isInQuit()||(En.log("Connection online handler called by Realtime!"),O&&Wt(),I=!0,se&&(O?tt:nt)(),je(),Ye())}function tt(){En.log("Client supports synchronization - starting to sync with server"),_.isObject(L)&&(q?(L.setInternalError(rn.WARNING_SYNC_AFTER_OFFLINE,tn.SYNCHRONIZATION),En.log("Client is editor - synchronizing with server using current client state"),le="editSync",p&&0<p.length&&wt()):(L.setInternalError(rn.WARNING_SYNC_FOR_VIEWER,tn.SYNCHRONIZATION),En.log("Client is viewer - waiting for server messages to unlock view"),le="viewSync"),L.executeDelayed(function(){!ce&&le&&(En.log("Synchronization time out detected - no synchronization possible"),ft({cause:"timeout"}))},"EditApplication.startSynchronizationProcessOT",3e4),le&&kt()&&(M.sync(),M.syncStable().then(function(e){En.log("SyncStable response received ",e),e&&e.docStatus?ft(null):ft({cause:"reset"})},function(){ft({cause:"reset"})}).done(function(){L.repeatDelayed(function(){return!le||ce?Qt.BREAK:kt()?void ft(null):(ft({cause:"reset"}),Qt.BREAK)},"EditApplication.startSynchronizationProcessOT",{delay:0,repeatDelay:3e3,cycles:9})})))}function nt(){if(En.log("Client supports synchronization - starting to sync with server"),_.isObject(L)&&(q?(L.setInternalError(rn.WARNING_SYNC_AFTER_OFFLINE,tn.SYNCHRONIZATION),En.log("Client is editor - synchronizing with server using current client state"),le="editSync",p&&0<p.length&&wt()):(L.setInternalError(rn.WARNING_SYNC_FOR_VIEWER,tn.SYNCHRONIZATION),En.log("Client is viewer - waiting for server messages to unlock view"),le="viewSync"),L.executeDelayed(function(){!ce&&le&&(En.log("Synchronization time out detected - no synchronization possible"),Et(0,null,null,{cause:"timeout"}))},"EditApplication.startSynchronizationProcess",3e4),le&&kt())){var n=-1,r=null,e=M.sync().then(function(e){if(En.log("Sync response received ",e),e&&e.docStatus){var t=U.getOperationStateNumber();return r=Qt.getStringOption(e.docStatus,"editUserId",""),n=Qt.getIntegerOption(e.docStatus,"serverOSN",-1),Et(V=r,t,n,null),$.when()}throw new Error("sync response contains no mandatory data - synchronization impossible!")},function(){Et(0,null,null,{cause:"reset"})});(e=e.then(function(){if(le&&kt()){var e=M.syncStable();return e.done(function(e){if(En.log("SyncStable response received ",e),e&&e.docStatus){var t=U.getOperationStateNumber();r=Qt.getStringOption(e.docStatus,"editUserId",""),Et(V=r,t,n,null)}else Et(0,null,null,{cause:"reset"})}),e.fail(function(){Et(0,null,null,{cause:"reset"})}),e}throw Et(0,null,null,{cause:"reset"}),new Error("synchronization not possible")},function(){Et(0,null,null,{cause:"reset"})})).done(function(){L.repeatDelayed(function(){if(!le||!kt())return Et(0,null,null,{cause:"reset"}),Qt.BREAK;var e=U.getOperationStateNumber();Et(_.isString(r),e,n,null)},"EditApplication.startSynchronizationProcess",{delay:0,repeatDelay:3e3,cycles:9})})}}function rt(){En.log("NoResponseInTime notification received - Server has not responded in a certain time"),L.isLocked()||L.isInQuit()||L.setInternalError(rn.WARNING_CONNECTION_INSTABLE)}function it(){if(En.log("Shutdown notification received - Document middleware node is going down!"),!L.isLocked()&&!L.isInQuit()&&kt()){var e=M.hasPendingActions()||L.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}};N&&e?L.setInternalError(rn.ERROR_SERVER_SHUTDOWN_NO_RESCUE_POSSIBLE,tn.CONNECTION,null,t):L.setInternalError(rn.ERROR_SERVER_GOING_TO_SHUTDOWN,tn.CONNECTION,null,t)}}function ot(){if(En.log("Crashed node notification received - Document middleware node is not available anymore!"),!L.isLocked()&&!L.isInQuit()&&kt()){var e=M.hasPendingActions()||L.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}};N&&e?L.setInternalError(rn.ERROR_SERVER_NODE_UNAVAILABLE_NO_RESCUE_POSSIBLE,tn.CONNECTION,null,t):L.setInternalError(rn.ERROR_SERVER_NODE_UNAVAILABLE,tn.CONNECTION,null,t)}}function at(e,t){if(En.log("Hangup notification received - document cannot be edited anymore!"),!L.isLocked()&&!L.isInQuit()&&kt()){var n=M.hasPendingActions()||L.hasUnsavedChanges(),r=new en(t);r.isError()||(r=new en(rn.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),ht()&&(n||function(e){var t=!1;if(en.isErrorCode(e)&&e.isError()){switch(e.getCodeAsConstant()){case"SAVEDOCUMENT_FILE_HAS_CHANGED_ERROR":case"GENERAL_FILE_NOT_FOUND_ERROR":case"GENERAL_PERMISSION_READ_MISSING_ERROR":case"GENERAL_PERMISSION_WRITE_MISSING_ERROR":case"LOADDOCUMENT_CANNOT_RETRIEVE_OPERATIONS_ERROR":t=!0}}return t}(r))?O?L.setInternalError(rn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,tn.CONNECTION):L.restoreDocument(r):"GENERAL_MALICIOUS_ACK_HANDLING_ERROR"!==r.getCodeAsConstant()||n?L.setInternalError(r,tn.CONNECTION):L.reloadDocument()}}function st(e,t){if(En.log("OT reload notification received - client must reload the document"),!L.isInQuit()){var n=new en(t);n.isError()||(n=new en(rn.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),lt(n,tn.CONNECTION)}}function lt(e,t){L.trigger("docs:reload:prepare"),L.setInternalError(e,t),L.executeDelayed(function(){L.reloadDocument()},"EditApplication.handleOTReload",1500)}function ct(e,t){if(!L.isInQuit())if(new en(t).isError())_e&&_e.reject(t);else{var n=Qt.getStringOption(t,"fileId",null),r=Qt.getStringOption(t,"fileName",null);n&&r?(_e&&_e.resolve(t),L.updateFileDescriptor({id:n,filename:r,title:Xt.getFileBaseName(r)}),w.action="load",delete w.template,A=!1,L.reloadDocument()):_e&&_e.reject(t)}}function dt(e){if(Vn.log("$back{lightgreen}handleEditRequestViaUpdate",e),!L.isInQuit()&&null===le&&!W&&V===k){var t=e&&_.isArray(e.activeUsers)?_.find(e.activeUsers,function(e){return e&&e.clientUID!==k&&e.requestsEditRights}):null,n=t?t.clientUID:null;if(n){if(Vn.log("$back{lightgreen}__handleEditRequestViaUpdate - clientUIDRequesting ",Ae,Ke(n)),Ae)return Vn.log("$back{lightgreen}__handleEditRequestViaUpdate - BLOCK OTHER REQUESTS?",n),void(Ae.clientUID!==n&&kt()&&(Vn.log("$back{lightgreen}__handleEditRequestViaUpdate - REQUEST BLOCKED!"),M.declineEditRights(n)));Vn.log("$back{lightgreen}__handleEditRequestViaUpdate - Request edit rights",a);var r=function(e){if(Vn.log("$back{MediumAquaMarine}handleEditRightsTransferRequest"),function(){var e=12e4,t=0<a,n=null,r=_.now()-De;Vn.log("inactivCheck knownWhenLastOpWasSend",t),t?(n=Date.now()-a,Vn.log("inactivCheck sendActionsTime",a,n)):(n=Date.now()-oe,Vn.log("inactivCheck importFinishedTime",oe,n));return Vn.log("inactivCheck User is inactive?",e<n,!Qt.wasKeyPressedWithinTime(e),"timeDeltaToLastTransfer",r,e<r),e<n&&!Qt.wasKeyPressedWithinTime(e)&&e<r}())return Rn(Kn);var i=L.newDeferred("EditApplication.handleEditRightsTransferRequest"),t=L.createAbortablePromise(i);Ae={deferred:i,promise:t,clientUID:e},Vn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - callForUserInput"),x.yell({type:"question",message:_n("%1$s is asking for edit rights. This request will be accepted automatically in %2$d seconds.",_.noI18n(Ke(e)),Math.floor(kn/1e3)),duration:kn,progress:!0,disableCloser:!0,restoreHidden:!0,priority:!0,renderFn:function(e){var t=$.button({label:_n("Decline")}).addClass("btn-default").css({marginRight:5});t.on("click tab",function(){Vn.log("$back{Orchid}__handleEditRightsTransferRequest - DECLINE BUTTON PRESSED BY USER"),De=Date.now(),Vn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: declined"),i.resolve(zn)});var n=$.button({label:_n("Accept")}).addClass("btn-primary");n.on("click tab",function(){Vn.log("$back{Orchid}__handleEditRightsTransferRequest - ACCEPT BUTTON PRESSED BY USER"),Vn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: accepted"),i.resolve(Yn)});var r=$('<div class="button-area" style="text-align:center;margin-top:10px;">');e.append(r.append(t,n))}});var n=L.executeDelayed(function(){Vn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - DECISION: accepted automatically"),i.resolve(Yn)},"EditApplication.handleEditRightsTransferRequest.autoAcceptTimer",{delay:kn,background:!0});return t.always(function(){Ae=null,n.abort(),x&&x.hideYell({priority:!0})}),t}(n);r.done(function(e){if(Vn.log("$back{lightgreen}__handleEditRequestViaUpdate - answer: "+e),e===zn)return Vn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer declined"),void(kt()&&M.declineEditRights(n));Vn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer accepted"),Ve(!(W=!0)),L.setCurrentInfoState(on.INFO_PREPARE_LOSING_EDIT_RIGHTS,{showMessage:e===Kn}),je(),L.getController().update();var t=F&&F.prepareLoseEditRightsHandler;(t?An(t.bind(L)):Rn()).always(function(){En.log("handle PrepareLosingEditRights"),L.executeDelayed(function(){!function e(t){L.hasUnsavedChangesOffice()?L.executeDelayed(function(){e(t)},"EditApplication.checkForPendingOperations",2e3):wt().then(function(){kt()&&M.canLoseEditRights(t),W=!1,L.getController().update(),En.log("sent canLoseEditRights")})}(n)},"EditApplication.handlePrepareLosingEditRights",1e3)})}),r.fail(function(e){Vn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer failure, reason:",e)})}}}function ut(){Ne.abort(),Vn.log("$back{SandyBrown}abortPendingEditRightsRequest")}function gt(){Ae&&(Ae.promise.abort(),Vn.log("abortPendingEditRightsTransfer"))}function pt(t){Vn.log("$back{lightblue}applyEditState - DOC UPDATE",t);var e=O?null:Qt.getStringOption(t,"editUserId",""),n=O?null:Ke(e),r=O?null:n||t.editUser,i=O?null:N,o=O?null:i,a=L.getFileDescriptor(),s=U.getOperationStateNumber(),l=O?null:Qt.getIntegerOption(t,"serverOSN",-1),c=new en(t),d=Qt.getIntegerOption(t,"lockedByUserId",-1),u=Qt.getBooleanOption(t,"writeProtected",null);if(O?En.log("$badge{EditApp} applyEditState: clientOSN = "+s):En.log("$badge{EditApp} applyEditState: clientOSN = "+s+", localServerOSN = "+l),!T&&Zn.some(function(e){return e in t})){if(O||e===V||(En.log("Edit rights changed, new editing user id: "+e),o=k===e,L.setCurrentInfoState(on.INFO_USER_IS_CURRENTLY_EDIT_DOC,{showMessage:!1}),Vn.log("$back{lightblue}__applyEditState - EDITOR HAS BEEN CHANGED","|editClientId:",e,"|oldEditClientId:",V),Ne.running&&""!==e&&(Vn.log("$back{lightblue}__applyEditState - FORCE TIMER ABORTED the editor has been changed"),ut())),Qt.getBooleanOption(t,"failSafeSaveDone",!1)&&Xt.propagateChangeFile(a),Qt.getBooleanOption(t,"hasErrors",!1))return L.setInternalError(rn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,tn.SYNCHRONIZATION),void En.error("synchronization to the server has been lost.");G||(gn.RESCUE_DOCUMENT_READONLY&&L.isRescueDocument()?(Ve(!(G=!0)),L.setInternalError(rn.WARNING_RESCUE_DOC_CANNOT_BE_CHANGED,tn.READONLY)):_.isBoolean(u)&&u?(Ve(!(G=!0)),L.setInternalError(rn.WARNING_NO_PERMISSION_FOR_DOC,tn.READONLY)):-1!==d&&ox.user_id!==d&&(Ve(!(G=!0)),L.setInternalError(rn.WARNING_DOC_IS_LOCKED,tn.READONLY),C=Qt.getStringOption(t,"lockedByUser",""))),G||W||(O?Ve(!0):(En.log("Edit mode: "+o),Ve(o),!o&&(!I||i||r!==R&&r.length)&&(R=r,L.setCurrentInfoState(on.INFO_USER_IS_CURRENTLY_EDIT_DOC)),I&&e&&e!==V&&(function(e){var t=V,n=e,r=[n];_.isString(t)&&0<t.length&&r.push(t);V=n,Ot(r)}(e),R=r),o&&!1===i&&L.setCurrentInfoState(on.INFO_EDITRIGHTS_RECEIVED),I&&!o&&i&&-1!==l&&l<s&&(L.setInternalError(rn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,tn.SYNCHRONIZATION),En.error("synchronization between client and server is broken. Switching editor into read-only mode. New edit mode: "+o+"Old edit mode: "+i+", local Server OSN: "+l+", Client OSN: "+s))),(c.isError()||c.isWarning())&&L.setInternalError(c,tn.GENERAL)),I=!0,je()}}function ft(e){var t=null,n=function(){if(0<p.length)return!0;var e=kt()?M.getPendingActions():null;return e&&_.isArray(e.actions)&&0<e.actions.length}();function r(){En.log("logSynchronizationState... ","\n     localChanges = ",n,"\n     rtConnection.getPendingActions() = ",kt()&&JSON.stringify(M.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(p),"\n     mustSyncNowMode = ",le,"\n     failedData = ",JSON.stringify(e))}if(le){if(En.log("Checking synchronization state with server"),e){switch(e.cause){case"timeout":En.log("Synchronization not possible - maybe connection instance is gone"),(t=new en(rn.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(tn.SYNCHRONIZATION),r(),le=null;break;case"notMember":case"reset":case"error:disposed":En.log("Synchronization not possible - connection instance is gone or rt-state broken"),(t=new en(rn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(tn.SYNCHRONIZATION),r(),le=null}Je(t)}switch(le){case"editSync":if(n)return;En.log("Synchronization successfully completed"),Ve(!(G=!1)),L.setCurrentInfoState(on.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0});break;case"viewSync":En.log("Synchronization for viewer completed"),L.setCurrentInfoState(on.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})}r(),le=null}}function Et(e,t,n,r){var i=null,o=function(){if(0<p.length)return!0;var e=kt()?M.getPendingActions():null;return _.isObject(e)&&_.isArray(e.actions)&&0<e.actions.length}();function a(e,t){En.log("logSynchronizationState... ","\n     localChanges = ",o,"\n     rtConnection.getPendingActions() = ",kt()&&JSON.stringify(M.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(p),"\n     mustSyncNowMode = ",le,"\n     clientOSN = ",e,"\n     serverOSN = ",t,"\n     oldEditUser = ",R,"\n     failedData = ",JSON.stringify(r))}if(le){if(En.log("Checking synchronization state with server"),r){switch(r.cause){case"timeout":En.log("Synchronization not possible - maybe connection instance is gone"),(i=new en(rn.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(tn.SYNCHRONIZATION),a(t,n),le=null;break;case"notMember":case"reset":case"error:disposed":En.log("Synchronization not possible - connection instance is gone or rt-state broken"),(i=new en(rn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(tn.SYNCHRONIZATION),a(t,n),le=null}Je(i)}switch(le){case"editSync":if(ht()){if(o)return;En.log("Synchronization successfully completed"),Ve(!(G=!1)),L.setCurrentInfoState(on.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0})}else o?(En.log("Synchronization not possible - editor changed"),(i=new en(rn.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)).setErrorContext(tn.SYNCHRONIZATION),L.restoreDocument(i)):n<=t?(En.log("Synchronization possible - but we lost edit rights"),G=!1,L.setCurrentInfoState(on.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(En.log("Synchronization not possible - did not receive missing operations"),L.reloadDocument());break;case"viewSync":n<=t?(En.log("Synchronization for viewer completed"),G=!1,L.setCurrentInfoState(on.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(En.log("Synchronization not possible - did not receive missing operations"),L.reloadDocument())}a(t,n),le=null}}function ht(){return O||k===V}this.getServerModuleDocUrl=function(e,t,n){if(!kt()||!ox.session||!this.hasFileDescriptor())return null;var r=this.getFileParameters(_.extend({},n,{encodeUrl:!0}));return t=_.extend({session:ox.session,uid:this.get("uniqueID"),docuid:M.getDocUID()},r,t),ox.apiRoot+"/"+e+"?"+_.map(t,function(e,t){return t+"="+e}).join("&")};var Ot=this.createSynchronizedMethod("EditApplication.applyUserData",function(e){Vn.log("$back{PaleGoldenRod}applyUserData - CLIENT UPDATE",e);var t=null;if(_.isArray(e)?(t={clients:{changed:[]}},_.each(e,function(e){t.clients.changed.push({clientUID:e})})):t=e,!_.isObject(t))return wn.error("$badge{EditApp} applyUserData: called without valid data: "+JSON.stringify(t)),$.when();var a=ne,n=Qt.getObjectOption(t,"clients",{}),r=[],i=[];if(V===k&&_.isArray(n.changed)&&0<n.changed.length&&dt({activeUsers:n.changed}),_.isArray(n.list))i=n.list;else if(_.isArray(n.left)||_.isArray(n.joined)||_.isArray(n.changed)){var o={};ne.forEach(function(e){o[e.clientUID]=e}),_.isArray(n.left)&&n.left.forEach(function(e){delete o[e]}),_.isArray(n.joined)&&n.joined.forEach(function(e){o[e.clientUID]=e}),_.isArray(n.changed)&&n.changed.forEach(function(e){o[e.clientUID]=_.extend({},o[e.clientUID],e)}),Object.keys(o).forEach(function(e){i.push(o[e])})}return 0===i.length?$.when():(_.each(i,function(t){var e=_.isObject(t)&&_.isString(t.clientUID),n=e&&!_.isNumber(t.userId)&&_.isNumber(t.id);e?n?r.push(L.getUserInfo(t.id).then(function(e){return t.userDisplayName=e.displayName,t.userOperationName=e.operationName,t})):r.push($.when(t)):wn.warn("$badge{EditApp} applyUserData: missing identifier")}),L.createResolvedPromise().then(function(){return $.when.apply($,r)}).done(function(){var e,t,n,r;if(te=_.map(arguments,function(e){var t=e;return _.isNumber(e.userId)||((t={}).clientUID=e.clientUID,t.userId=e.id,t.userName=e.userDisplayName,t.userOperationName=e.userOperationName,t.guest=e.guest),t.active=!0===e.active||_.isNumber(e.durationOfInactivity)&&e.durationOfInactivity<60,t.remote=k!==t.clientUID,t.editor=V===t.clientUID,_.isObject(e.userData)&&(t.userData=e.userData),t.clientUID in X||(X[t.clientUID]=ee,ee+=1),t.clientIndex=X[t.clientUID],t.colorIndex=L.getAuthorColorIndex(t.userOperationName),t}),ne=_.where(te,{active:!0}),ne=_.sortBy(ne,"clientIndex"),!_.isEqual(a,ne)){wn.info("$badge{EditApp} applyUserData: activeClients=",ne),t=ne,(e=a).length===t.length&&(n=_.copy(e,!0),r=_.copy(t,!0),_.each(n,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.each(r,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.isEqual(n,r))||L.trigger("docs:users",ne),Ae&&!_.findWhere(ne,{clientUID:Ae.clientUID})&&gt();var i=_.first(_.pluck(_.where(a,{clientUID:k}),"requestsEditRights")),o=_.first(_.pluck(_.where(ne,{clientUID:k}),"requestsEditRights"));!0===i&&!1===o&&(Vn.log("$back{PaleGoldenRod}__applyUserData - REQUEST_EDITRIGHTS FOR USER -> is false - > event spinner off",i,o,V!==k),ut(),V!==k?(Vn.log("$back{PaleGoldenRod}__applyUserData - YOUR REQUEST WAS DECLINED"),x.yell({message:_n("Your request for edit rights has been declined.")})):De=_.now()),L.trigger("docs:users:selection",ne)}}))});function _t(){O&&0<$e.length&&!U.isProcessingActions()&&!function e(t){mt(t,!0).done(function(){$e.shift(),0<$e.length&&e($e[0])})}($e[0])}function St(e,t){var n;Le<e?t?e===Le+1?(Le=e,xe=-1):(xe=e,Gn.info("$badge{EditApp} setServerOSN: Saving OSN from ack temporarily: "+xe)):(Le+1<e&&Gn.info("$badge{EditApp} setServerOSN: Setting server OSN. Info: Increasing OSN by more than 1. Increasing from: "+Le+" to "+e),n=Le,xe===(Le=e)+1?(Gn.info("$badge{EditApp} setServerOSN: Updating server OSN with saved ack osn: "+xe+". Triggering event: docs:ackosn:updated."),Le=xe,xe=-1,L.trigger("docs:ackosn:updated")):0<=xe&&xe<Le&&(Gn.error("$badge{EditApp} setServerOSN: ERROR: Setting server OSN. Receiving OSN from external operation: "+e+". But still have temporary OSN from acknowledge: "+xe),Gn.error("$badge{EditApp} setServerOSN: ERROR: Current locally used server OSN is: "+n),xe=-1,L.trigger("docs:ackosn:updated"))):Gn.info("$badge{EditApp} setServerOSN: Setting server OSN. Avoiding to set server OSN to: "+e+". Current OSN is already: "+Le),Gn.info("$badge{EditApp} setServerOSN: Setting server OSN to: "+Le),U.trigger("change:osn",Le)}function mt(e,t){if(T)return En.error("$badge{EditApp} applyRemoteOperations: failed due to internal error"),$.Deferred().reject();var n=O?mn(e.docStatus,"serverOSN",-1):0;if(n<0)return wn.error("$badge{EditApp} applyRemoteActions: missing server OSN in external operations"),$.Deferred().reject();var r=Jn(e);if(0===r.length)return O&&St(n),$.when();if(pn.handleMinifiedActions([{operations:r}],!0),O||U.undoManager.clearUndoActions(),En.log("$badge{EditApp} applyRemoteOperations: last remote operation: "+JSON.stringify(_.last(r))),O){if(U.isProcessingInternalOperations()||0<$e.length&&!t)return t||$e.push(e),L.createResolvedPromise({cached:!0});if(Gn.info("$badge{EditApp} applyRemoteOperations: received external operations with server OSN "+n),St(n),0<Fe.length)try{ke+=r.length,r=L.otManager.transformOperations(r,Fe)}catch(e){return"OTError"===e.name?(p=[],lt(new en(rn.ERROR_CLIENT_OT_UNRESOLVABLE_OP_CONFLICT_ERROR))):Gn.exception(e,"$badge{EditApp} applyRemoteOperations: operation transformation failed"),$.Deferred().reject({cause:"operation"})}else Gn.trace("$badge{EditApp} applyRemoteOperations: external operations not transformed:",r)}var i=U.applyExternalOperations(r);return i.done(function(){D=!0}),i.fail(function(){L&&!L.isInQuit()&&En.error("$badge{EditApp} applyRemoteOperations: failed")}),i}var It=this.createSynchronizedMethod("EditApplication.applyUpdateMessageData",function(s){if(function(e){if(!O){var t=!1,n=U.getOperationStateNumber();return gn.RESTORE_DOCUMENT_ENABLED&&0<e.length&&(t=!("editSync"!==le||!kt()||!M.hasPendingActions())||n!==e[0].osn),t}}(Jn(s)))return O?L.setInternalError(rn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,tn.CONNECTION):le||ht()?L.restoreDocument(new en(rn.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)):L.setInternalError(rn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,tn.CONNECTION),$.when();var e=mt(s);return e.done(function(e){var t,n,r,i,o,a;_.isObject(s)&&!_.isObject(s.docStatus)&&wn.error("$badge{EditApp} broadcast_update sent bad data "+JSON.stringify(s)),O&&e&&e.cached||(pt(s.docStatus),t=s,n=L.getFileDescriptor(),r=Qt.getStringOption(t,"fileName",""),i=Qt.getStringOption(t,"com.openexchange.file.sanitizedFilename",""),o=Qt.getStringOption(t,"fileVersion",""),a={},0<r.length&&r!==Qt.getStringOption(n,"filename")&&(a.filename=r),0<i.length&&i!==Qt.getStringOption(n,"com.openexchange.file.sanitizedFilename")&&(a["com.openexchange.file.sanitizedFilename"]=i),0<o.length&&o!==Qt.getStringOption(n,"version")&&(a.version=o),T||_.isEmpty(a)||(L.updateFileDescriptor(a),L.getController().update(),je()))}),e});function Rt(e){if(!_.isObject(e))return wn.error("$badge{EditApp} registerUpdateMessageData: invalid response (object expected):",e),this.setInternalError(rn.ERROR_WHILE_MODIFYING_DOCUMENT,tn.GENERAL),$.Deferred().reject();if(En.log("$badge{EditApp} registerUpdateMessageData: received update message:",e),0<re.length&&k!==e.editUserId){En.log(" "+re.length+' existing pending updates must be changed to user "'+e.editUserId+'"');var t={editUser:e.editUser,editUserId:e.editUserId};re.forEach(function(e){_.extend(e,t)})}re.push(e);var n=It(e);return n.always(function(){re.shift(),En.log("$badge{EditApp} registerUpdateMessageData: update processed, "+re.length+" pending messages left")}),n}function Nt(e,t,n){if(!e)return Rn();var r=An(e.bind(L)).fail(function(){wn.warn("$badge{EditApp} failed initialization step: "+n)});return r=r.then(function(e){return L.isInQuit()?Nn({cause:"closing"}):e}),L.launchTracker.asyncStep(r,t,"$badge{EditApp} "+n)}function At(e){if(_.isObject(L)&&!L.isInQuit()||(e={cause:"quit"}),de)return{cause:""};var t,n=new en(e),r=n.getCodeAsConstant();switch(T=!0,s.call(L,e),e=_.clone(e),r){case"GENERAL_FILE_NOT_FOUND_ERROR":b=!0}return n.isError()||(n=(t=e)&&t.error_desc&&t.error_id&&_.isString(t.error_desc)&&_.isString(t.error_id)?function(e){if(n=new en(en.GENERAL_ERROR),e&&e.error_desc){var t=e.error_desc;n.setDescription(t)}return n}(e):new en(rn.ERROR_UNKNOWN_REALTIME_FAILURE)),L.isInQuit()||L.setInternalError(n,tn.LOAD,null,{showMessage:!1}),e=_.extend({},e,{errorForErrorCode:L.isViewerMode()}),de=!0,e}function Dt(e,t){var n={operations:e||[]};return t&&(n.userData=t),n}function vt(){return i&&i.operations&&0<i.operations.length}function yt(){return r||0<p.length||vt()}function bt(t){bn(Fe,function(e){return!e[t]})}var Ct,Tt,wt=(Ct=null,function(){if(En.log("$badge{EditApp} sendActions: entered"),r)return En.log("$badge{EditApp} sendActions: sending in progress - using current promise"),Ct.promise();if(T)return En.error("$badge{EditApp} sendActions: internal error detected - promise rejected!"),$.Deferred().reject();if(O&&(bn(p,function(e){return 0<e.operations.length}),bn(Fe,function(e){return 0<e.operations.length})),0===p.length)return En.log("$badge{EditApp} sendActions: no need to send action buffer empty"),$.when();if(O){if(0<=xe)return Gn.info("$badge{EditApp} sendActions: Not all external operations are currently applied. Coming back later, when all external ops are applied!"),L.once("docs:ackosn:updated",Vt),Ct.promise();if(U.isProcessingExternalOperations())return Gn.info("$badge{EditApp} sendActions: External operations are currently applied. Coming back later in operations:after handler!"),U.one("operations:after",jt),Ct.promise()}return Ct=L.createDeferred("EditApplication.sendActions").always(function(){En.log("$badge{EditApp} sendActions: current send promise resolved - sendingActions = false"),r=!1,a=_.now(),je()}),r=!0,je(),function t(){if(gn.REALTIME_DEBUGGING&&W&&p&&0<p.length){var e=p[p.length-1].operations;e&&0<e.length&&wn.log("$badge{EditApp} sendActionsBuffer: last action:",_.last(e))}if(O&&we)return L.executeDelayed(function(){t()},"sendActionsBuffer",1e3),void Ct.resolve();if(l&&c){var n=O?p.length:0;p=l.call(L,p),O&&p.length!==n&&bt("_OPTIMIZED_OPERATION_")}qn("$badge{EditApp} sendActions: sending local actions, serverOSN="+Le,p),p=pn.handleMinifiedActions(p),O&&Fe.forEach(function(e){e.sentToServer=!0});var r=p.map(function(e){return{operations:e.operations}}),i=O?Le:void 0,o=kt()?M.sendActions(r,i):L.createRejectedPromise();o.done(function(e){O&&(Gn.info("$badge{EditApp} sendActions: Receiving acknowledge with new OSN sent from server: "+e.body.serverOSN),St(e.body.serverOSN,!0),Gn.info("$badge{EditApp} sendActions: Trying to clear local operation cache after receiving acknowledge"),qt()),T?(En.error("$badge{EditApp} sendActionsBuffer: sent successfully, but internal error detected!"),Ct.reject()):0===p.length?Ct.resolve():O&&U.isProcessingExternalOperations()?(Gn.info("$badge{EditApp} sendActions: External operations are currently applied. Calling sendActions later in operations:after handler!"),U.one("operations:after",jt),Ct.resolve()):O&&0<xe?(Gn.info("$badge{EditApp} sendActions: External operations are still missing. Calling sendActions later in operations:after handler!"),U.one("operations:after",jt),Ct.resolve()):t()}),o.fail(function(e){En.error("$badge{EditApp} sendActionsBuffer: rtConnection.sendActions promise failed!"),Ct.reject(e)}),p=[]}(),Ct.promise()}),Ft=(Tt=L.createDebouncedMethod("EditApplication.storeAndSendDebounced",function(t){var e=!1;En.log(function(){var e=0<t.operations.length?JSON.stringify(_.last(t.operations)):null;return"$badge{EditApp} storeAction: "+(e?"last operation: "+e:"no operations provided")}),h&&0<Oe.length&&(p=h.call(L,p,Oe),Oe=[],e=!(h=null)),!T&&(0<t.operations.length||e)&&(0<t.operations.length&&(p.push(t),O&&(Fe.push(t),qn("$badge{EditApp} registerAction: added local action without ACK to cache",Fe))),o=A=!0,je())},wt,{delay:d,maxDelay:d}),function(e){Ee?Tt(e):(En.log("$badge{EditApp} registerAction: cached action during non-distribution mode"),Oe.push(e))});function Lt(t){var e=x.processUnsavedComment(t===Mn.QUIT);return e=(e=(e=e.then(function(){return v})).then(function(){var e=F&&F.prepareFlushHandler;return e?e.call(L,t):null})).then(function(){var e=wt();return t===Mn.QUIT&&(e=er(e,5e3,"EditApplication.prepareFlushDocument")),e})}var Ut,xt=_.once(function(){if(Ve(!(Ge=!0)),kt()){var e=F&&F.prepareLeaveDataHandler,t=e?e.call(L):null;M.emergencyLeave(t)}});function kt(){return!(!M||M.destroyed)}function $t(){M&&(ut(),gt(),M.destroy(),L.rtConnection=M=null)}function Pt(e,t,n){if(Ge||!kt())return Nn();var r=null,i=M.getConnectOpenState();if(En.log("$badge{EditApp} executeShutdownStep: - silentShutdownEntered:",Mt()," connectionOpenState:",i," action:",e),!Mt()){var o=!1,a=!1,s=!1;switch(i){case"unknown":case"joining":s=a=o=!1;break;case"joined":s=!(a=o=!1);break;case"opening":s=!(a=!(o=!0));break;case"opened":s=a=!(o=!1)}r=function(){switch(e){case".abortOpen":return o?M.abortOpen():null;case".closeDocument":return a?M.closeDocument(t):null;case".disconnect":return s?M.disconnect(t):null}}()}return Mt()&&(r=function(){switch(e){case".closeDocument:force":return M.closeDocument(t);case".disconnect:force":return M.disconnect(t)}}()),r?n?er(r,n,'EditApplication.executeShutdownStep("'+e+'")'):r:Nn()}function Mt(){return!(null===be)}function Bt(e){var o=Qt.getBooleanOption(e,"skipCloseDoc",!1),a=Qt.getBooleanOption(e,"skipDisconnect",!1);if(En.log("$badge{EditApp} silentShutdownConnection entered! - silentShutdownConfig:",e,"silentShutdownConnectionEntered",Mt()),!Mt()){Ve(!(G=!0)),O&&Ue.abort();var s,l=$.Deferred();be=l.promise(),kt()&&M.off(),(s=o?$.when():Pt(".closeDocument:force",{no_restore:ve},500)).always(function(e){var t;if(a)t=$.when();else{var n="timeout"===e,r="rejected"===s.state(),i=n||Boolean(o)||r;En.log("$badge{EditApp} silentShutdownConnection: closeDocument rejected by timeout?:",n),t=Pt(".disconnect:force",i,500)}t.always(function(){$t(),En.log("$badge{EditApp} silentShutdownConnection is finished"),l.resolve()})})}}function Ht(c,e){var d=L.getWindow();function t(e){var t,n,r,i,o=L.createDeferred("EditApplication.checkCloseDocumentResult"),a=new en(e),s={},l=null;return a.isError()||a.isWarning()?(t=Qt.getStringOption(e,nn.RESTORED_FILEID,null),n=Qt.getStringOption(e,nn.RESTORED_FILENAME,null),r=Qt.getStringOption(e,nn.RESTORED_FOLDERID,null),l=Qt.getStringOption(e,nn.RESTORED_ERRORCODE,"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"),_.isString(t)&&_.isString(n)&&_.isString(r)?(l=l===en.CONSTANT_NO_ERROR?new en({errorClass:en.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"}):new en({errorClass:en.ERRORCLASS_ERROR,error:l}),s[nn.RESTORED_FILENAME]=n,Xt.getPath(r).always(function(e){s[nn.RESTORED_PATHNAME]=Xt.preparePath(e),s[nn.ORIGINAL_FILEID]=L.getFileDescriptor().id,L.updateFileDescriptor({id:t,folder_id:r}),L.setInternalError(l,tn.CLOSE,a,{additionalData:s})})):L.setInternalError(a,tn.CLOSE,null,{additionalData:s}),U&&x?(L.registerQuitHandler(function(){o.reject()}),L.quit=(i=L.quit,function(){return o.reject(),i.call(L)}),d.idle(),o.always(function(){d.busy()}),c===Bn.LOGOUT&&o.reject()):o.reject(),a.getDescription()&&wn.log(a.getDescription()),o.promise()):e}return Pt(".closeDocument",e=e||null,8e3).then(t,function(e){return"timeout"===e?L.createRejectedPromise(e):t(e)})}function Gt(){Gn.info("$badge{EditApp} clearLocalActionsWithoutAckAfterEvent: Clearing the local actions!"),qt()}function qt(){U.isProcessingExternalOperations()?(U.off("operations:after",Gt),Gn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are currently applied. Coming back later after event operations:after!"),U.on("operations:after",Gt)):0<xe?(L.off("docs:ackosn:updated",Gt),U.off("operations:after",Gt),Gn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are still missing. Coming back later after event docs:ackosn:updated or operations:after!"),L.on("docs:ackosn:updated",Gt),U.on("operations:after",Gt)):(Gn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. Before: "+JSON.stringify(Fe)),U.off("operations:after",Gt),L.off("docs:ackosn:updated",Gt),bt("sentToServer"),Gn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. After: "+JSON.stringify(Fe)))}function jt(){Gn.info("$badge{EditApp} sendActionsAfterApplyingExternalOperations: Sending actions after receiving operations:after event!"),wt()}function Vt(){Gn.info("$badge{EditApp} sendActionsAfterReceivingRequiredExternalOperations: Sending actions after receiving docs:ackosn:updated event!"),wt()}function Wt(){L.isOnline()&&Jt.isTabVisible()&&Ue.start()}this.leaveBusyDuringImport=_.once(function(e,t){return ie=L.launchTracker.step("previewStart","$badge{EditApp} Busy state during import process left"),je(),x.showAfterImport(e,t)}),this.createDebouncedActionsMethodFor=function(t,e,n,r,i){var o=!1;return t.createDebouncedMethod(e,n,function(){if(!o){if(!L.isImportFinished()||!U.isProcessingActions())return r.call(t);var e=U.waitForActionsProcessed();o=!0,t.await(e,function(){o=!1,r.call(t)})}},i)},this.checkStartOfExternalOperations=function(){!O||i||U.isProcessingInternalOperations()||L.trigger("docs:operations:completed")},this.isRemovalOfInternalBlockerPossible=function(){return O&&!i&&!U.isDrawingChangeActive()},this.getFileFormat=function(){var e;return null===n&&(e=this.hasFileDescriptor()?this.getFullFileName():w&&w.templateFile?w.templateFile.filename:"",n=e?cn.getFileFormat(e):null),n||"ooxml"},this.isOOXML=function(){return"ooxml"===this.getFileFormat()},this.isODF=function(){return"odf"===this.getFileFormat()},this.isTemplateFile=function(){return this.hasFileDescriptor()&&cn.isTemplate(this.getFullFileName())},this.isScriptable=function(){return this.hasFileDescriptor()&&cn.isScriptable(this.getFullFileName())},this.isShutdownReceived=function(){return!1},this.getClientId=function(){return k},this.getShortClientId=function(){return k.slice(0,4)},this.getDocUID=function(){return kt()?M.getDocUID():null},this.getLoadMode=function(){return Te},this.getEditClientId=function(){return V},this.getEditClientUserName=function(){return Ke(V)},this.getClientOperationName=function(){return P},this.getActiveClients=function(){return ne},this.isLocallyModified=function(){return A},this.isPrepareLosingEditRights=function(){return W},this.sendActionRequest=function(t,n,r){if(!kt())return L.createRejectedPromise();var e={action:t,docuid:M.getDocUID(),requestdata:JSON.stringify(n)};r=_.extend({method:"POST"},r);var i=this.sendFileRequest(Cn,e,r);return i.fail(function(e){wn.warn("$badge{EditApp} sendActionRequest: failed: ",t,n,r,e)}),i},this.sendAddImageIdRequest=function(e){return kt()?M.addImageId(e).then(_.constant(e)):Rn(e)},this.sendLogMessage=gn.LOG_ERROR_DATA?function(e){return L&&L.allowStoreLogFile()&&L.sendLogErrorData({errorCode:e}),this}:Qt.NOOP,this.isRenameEnabled=function(){return!xn&&(!Q&&!gn.getDebugFlag("office:simple-filestore")||!this.isDocumentEncrypted()&&!O)},this.rename=function(e){var t=this.getFileDescriptor(),r=Qt.getStringOption(t,"filename",this.getFullFileName()),n=Qt.getStringOption(t,"com.openexchange.file.sanitizedFilename",r),i=vn(e);if(this.setUnsavedFileName(null),v)return wn.warn("$badge{EditApp} rename: multiple calls, ignoring subsequent call"),v;if(0===i.length)return $.Deferred().reject();if(i===this.getShortFileName())return $.when();i+="."+this.getFileExtension(),this.isDocumentEncrypted()&&(i+=Xt.GUARD_EXT),this.updateFileDescriptor({filename:i}),_e=this.createDeferred("EditApplication.renameAndReload",{background:!0});var o=F&&F.prepareRenameHandler;return(v=(v=(v=(v=o?An(o.bind(L)):Rn()).then(wt)).then(function(){return kt()?M.renameDocument({target_filename:i}):Nn()})).then(function(e){var t=new en(e);return t.isWarning()&&"RENAMEDOCUMENT_SAVE_IN_PROGRESS_WARNING"===t.getCodeAsConstant()?_e.promise():t.isError()?Nn(t):e})).done(function(e){y=!0,L.updateFileDescriptor({filename:Qt.getStringOption(e,"fileName",r),"com.openexchange.file.sanitizedFilename":Qt.getStringOption(e,"com.openexchange.file.sanitizedFilename",n)})}),v.fail(function(e){if("abort"!==e){var t=en.isErrorCode(e)?e:new en(e);t.setErrorContext(tn.RENAME);var n=an.getMessageData(t);n.restoreHidden=!1,wn.warn("$badge{EditApp} rename: error: "+t.getErrorText()),x.yell(n)}L.updateFileDescriptor({filename:r})}),v.always(function(){v=null})},this.getCurrentFileName=function(){return v?x.getToolbarFileNameFieldValue():L.getShortFileName()},this.hasUnsavedChangesOffice=function(){return yt()||!!v||this.hasUnsavedFileName()||!!U&&U.hasUnsavedComments()},this.hasUnsavedChanges=function(){return(!ox.tabHandlingEnabled||Kt.getLoggingOutState()!==Kt.LOGGING_OUT_STATE.FOLLOWER)&&(!(!kt()||!M.isConnected())&&(this.hasUnsavedChangesOffice()||M.hasPendingActions()))},this.setUserState=function(e){return this.isInternalError()||m===e||(m=e,qe()),this},this.getState=function(){return m&&!this.isInternalError()?m:S},this.isEditable=function(){return N},this.isOnline=function(){return"offline"!==S},this.isInternalError=function(){return"error"===S},this.setInternalError=function(e,t,n,r){var i,o=en.isErrorCode(e)?e:new en(e),a=null,s=null,l=null,c=!0,d=Qt.getObjectOption(r,"additionalData",{}),u=en.isErrorCode(n)?n:o,g=!1,p=Qt.getObjectOption(r,"silentShutdownConfig",{}),f=o.isError();if(L.isReloading()&&L.setAppReloadDone(L),_.isString(t)&&o.setErrorContext(t),a=L.getErrorState(),(i=!_.isObject(a)||!a.isError())?(L.setErrorState(o),g=!0):_.isObject(a)&&(o=a,s=ye),l=L.getErrorState(),en.isErrorCode(l)&&wn.error("$badge{EditApp} Internal error: "+l.getErrorText()),f)Ve(!(G=!(I=!(T=!0)))),Bt(p);else{var E=!_.has(ue,o.getCodeAsConstant()),h=ge!==o.getCodeAsConstant();c=E&&h,an.isOnceWarning(o.getCodeAsConstant())&&(ue[o.getCodeAsConstant()]=!0),ge=o.getCodeAsConstant()}je(o),_.isObject(s)&&!g||(s=an.getMessageData(o,_.extend({causeError:u,viewerMode:L.isViewerMode()},We(),d)),L.extendMessageData(s),Ie="document/reload"===Qt.getStringOption(s.action,"itemKey"),ye=s),Qt.getBooleanOption(r,"showMessage",!0)&&c&&x&&x.yell&&x.yell(s),f&&i&&(L.sendLogErrorData({errorCode:o.getCodeAsConstant()}),L.allowStoreLogFile()&&an.createCrashDataForError(o.getCodeAsConstant())&&L.createLogFileInDrive())},this.createLogFileInDrive=function(){var e=L.generateLogData();if(e){var t=_n("A debug report is uploaded to Drive/myFiles/crashdata. This can take a while. Closing the browser tab cancels the upload. The report may contain content of previously opened documents."),n=new Pn(t,{title:_n("Generating debug report"),classes:"generate-log-dialog",okLabel:On.CLOSE_LABEL,showReadOnly:!0}),r=_n("Finished upload"),i=_n("Could not upload file"),o=$('<div style="padding: 10px 0; text-align: center; font-weight: 400; font-size: 14px" class="result"><div class="busy-indicator io-ox-busy"></div></div>');n.append(o),n.show(),L.sendLogErrorData({logData:e}).done(function(){o.html('<i class="fa fa-check" aria-hidden="true"></i><span <div style="padding: 0px 5px">'+r+"</span>")}).fail(function(){o.html('<i class="fa fa-exclamation-circle" aria-hidden="true"></i><span style="padding: 0px 5px">'+i+"</span>")})}},this.allowStoreLogFile=function(){return gn.LOG_ERROR_DATA&&!!L&&!L.isDocumentEncrypted()},this.sendLogErrorData=function(e){var t=_.has(e,"errorCode"),n=_.has(e,"logData");if(!t&&!n)return L.createRejectedPromise();function r(e){return a?"hidden":e}var i,o,a=!gn.LOG_ERROR_DATA,s=L.getFileDescriptor(),l={action:"logclientdata",logAnonymous:String(a),fileId:String(r(s&&s.id)),folderId:String(r(s&&s.folder_id)),fileName:String(r(L.getFullFileName())),userId:String(ox&&ox.user_id),docUid:String(Me),errorCode:t?(o=e&&e.errorCode,String(o||"unknownError")):"",logData:n&&L.allowStoreLogFile()?(i=e&&e.logData,String(i)):""};return L.sendRequest(Cn,l,{method:"POST",dataType:"xml"})},this.setCurrentInfoState=function(e,t){var n=null,r=Qt.getBooleanOption(t,"showMessage",!0),i=null;Qt.getBooleanOption(t,"resetWarning",!1)&&(i=L.getErrorState(),_.isObject(i)&&i.isError()||L.setErrorState(new en)),L.setInfoState(e),r&&(n=sn.getMessageData(e,_.extend({},We(),t)),L.extendMessageData(n),_.isObject(n)&&x.yell(n))},this.isLocked=function(){return T||G},this.isAcquireEditRightsEnabled=function(){return!O&&kt()&&!this.isLocked()&&this.isOnline()&&!N},this.isAcquireEditRightsEnabledPendingUpdates=function(){return this.isAcquireEditRightsEnabled()&&re.length<=1},this.acquireEditRights=function(){if(Vn.log("$back{Orchid}acquireEditRights - User wants to acquireEditRights -> Button pressed  "),this.isAcquireEditRightsEnabled())return Ne.start();ut()},this.saveDocumentAs=function(n,e,r,i){var o=e,a=null,s=L.getFileDescriptor(),t=null,l=!1;switch(r){case Ln.NATIVE:if(i&&i.encrypted){o+="."+L.getFileExtension()+Xt.GUARD_EXT,t=(t=(t=Xt.authorizeGuard().then(function(e){w.auth_code=e},function(){return l=!0,Nn()})).then(function(){return L.flushDocument(Mn.DOWNLOAD)})).then(function(){var e=s.file_options||{},t=e.params||{};return _.extend(t,{cryptoAction:"Encrypt",filedisplay:o,ignoreWarnings:!1}),s.file_options=_.extend(e,{params:t}),Xt.copyFile(s,n)});break}case Ln.TEMPLATE:o+="."+L.getFileExtension(),t=(t=L.flushDocument(Mn.DOWNLOAD)).then(function(){return kt()?M.copyDocument({file_id:L.getFileParameters().id,target_filename:e,asTemplate:r===Ln.TEMPLATE,target_folder_id:n}):Nn()});break;case Ln.PDF:o+=".pdf",t=(t=(t=L.flushDocument(Mn.DOWNLOAD)).then(function(){return Xt.propagateChangeFile(s)})).then(function(){return Xt.getFileModelFromDescriptor(s).then(function(e){return Yt.sendConverterRequest(e,{documentformat:"pdf",saveas_filename:o,saveas_folder_id:n})})});break;default:return wn.error('$badge{EditApp} saveDocumentAs: unknown file type "'+r+'"'),Nn()}return(t=(t=(t=t.then(function(e){var t=new en(e);return t.isError()?Nn(t):e})).then(function(t){return o=Qt.getStringOption(t,"filename")||o,Xt.deleteFromCache(n),Xt.getPath(n).then(function(e){return a=Xt.preparePath(e),t})})).then(function(e){if(r!==Ln.PDF){r===Ln.TEMPLATE&&L.setCurrentInfoState(on.INFO_DOC_SAVED_AS_TEMPLATE,{fullFileName:o,fullPathName:a,type:"success",duration:1e4});var t=Qt.getStringOption(e,"id",null);return!t&&i&&i.encrypted&&(t=_.isArray(e)?Qt.getStringOption(_.first(e),"data",null):e),n=n||Qt.getStringOption(e,"folder_id",null),Xt.getFile({id:t,folder_id:n}).then(function(e){e.title=Xt.getFileBaseName(e.filename),L.updateFileDescriptor(e),w.action="load",delete w.template,L.reloadDocument();var t=L.newDeferred("EditApplication.saveDocumentAs.keepBusyScreenOpen");return L.createAbortablePromise(t)})}L.setCurrentInfoState(on.INFO_DOC_SAVED_IN_FOLDER,{fullFileName:o,fullPathName:a,type:"success",duration:1e4})})).fail(function(e){"destroy"!==e&&("cancel"===e||l||(Yt.isDocConverterError(e)?x.yell({type:"error",message:Yt.getErrorTextFromResponse(e)}):((e=en.isErrorCode(e)?e:new en(en.GENERAL_ERROR)).setErrorContext(tn.SAVEAS),wn.warn('$badge{EditApp} saveDocumentAs: Error code "'+e.getCodeAsConstant()+'"'),x.yell(an.getMessageData(e,We())))))}),t},this.isReloadEnabled=function(){return Ie},this.reloadDocument=function(e,t){this.trigger("docs:reload:prepare");var n=this.getFileDescriptor(),r=this.getFullFileName(),i=cn.getEditModule(r);if(!i)return wn.error("$badge{EditApp} reloadDocument: unknown application type"),Nn();if(!cn.isNative(r))return wn.error("$badge{EditApp} reloadDocument: unsupported document type"),Nn();e=_.extend({},e,{action:"load",file:n}),w.auth_code&&(e.auth_code=w.auth_code),e.activeTabId=x.getToolBarTabs().getActiveTabId(),e.commentsPaneVisible=x.commentsPane&&x.commentsPane.isVisible();var o=F&&F.prepareReloadHandler;return o&&_.extend(e,o.call(this)),x.isBusy()||t||x.enterBusy(),wn.info("$badge{EditApp} reloadDocument: start reloading the document",e),this.quit(Bn.RELOAD,{editModule:i+"/main",reloadLaunchOptions:e})},this.restoreDocument=function(l,e){var t=Qt.getArrayOption(e,"actions",null),n=L.getFileDescriptor(),r=null;if(gn.RESTORE_DOCUMENT_ENABLED){if(!me){if(ve=!(me=!0),_.isNull(t)){var i=pn.handleMinifiedActions(p);r=kt()?(o=M.getPendingActions(),a=i,s=pn.getActionsArray(o),c=pn.getActionsArray(a),_.isArray(s)&&_.isArray(c)?s.concat(c):s):i}else r=t;var o,a,s,c;Ve(!(G=!0)),je(),T=!0;var d={action:"saveaswithbackup",file_id:n.id,target_filename:n.filename,target_folder_id:n.folder_id,restore_id:Se,operations:_.isNull(r)?r:JSON.stringify(r)};L.sendFileRequest(Cn,d,{method:"POST"}).then(function(e){var n=new en(e),t=L.newDeferred("EditApplication.restoreDocument"),r=Qt.getStringOption(e,nn.RESTORED_FILEID,null),i=Qt.getStringOption(e,nn.RESTORED_FILENAME,null),o=Qt.getStringOption(e,nn.RESTORED_FOLDERID,null),a=null,s={};_.isObject(e)&&_.isString(i)&&_.isString(o)?Xt.getPath(o).always(function(e){a=Xt.preparePath(e),t.resolve(a)}):t.resolve(null),t.always(function(e){var t=_.isString(e);n.isError()||(n=new en({errorClass:en.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"})),s[nn.RESTORED_FILENAME]=i,s[nn.RESTORED_PATHNAME]=a,s[nn.ORIGINAL_FILEID]=L.getFileDescriptor().id,t&&L.updateFileDescriptor({id:r,folder_id:o}),L.setInternalError(n,l.getErrorContext(),l,{additionalData:s})})},function(){L.setInternalError(l)})}}else L.setInternalError(l)},this.rejectEditAttempt=function(e){if(L.isViewerMode())return this;switch(e){case"image":x.yell({message:_n("The image could not be inserted.")});break;case"siri":L.setInternalError(rn.ERROR_SIRI_NOT_SUPPORTED,tn.GENERAL);break;case"loadingInProgress":L.setCurrentInfoState(on.INFO_LOADING_IN_PROGRESS);break;default:L.isImportFinished()?Ye():L.setCurrentInfoState(on.INFO_LOADING_IN_PROGRESS)}return this},this.getUserInfo=function(e){return this.createResolvedPromise().then(function(){return zt.get({id:e})}).then(function(e){var t=!!e.guest_created_by,n=_.noI18n(e.display_name||e.email1||""),r=t?"User "+e.user_id:e.first_name&&e.last_name?_.noI18n(e.first_name+" "+e.last_name):e.last_name?_.noI18n(e.last_name):e.first_name?_.noI18n(e.first_name):n;return{id:e.user_id,displayName:n,operationName:r,guest:t}})},this.updateUserData=(Ut=null,L.createDebouncedMethod("EditApplication.updateUserData",function(e){return Ut=e,this},function(){!kt()||"resolved"!==L.getImportFinishPromise().state()||T||L.isInQuit()||M.updateUserData("updateuserdata",Ut)},{delay:500,maxDelay:1e3})),this.registerAuthorItem=function(e){if("authorId"in e&&"authorName"in e){var t=e.authorId,n=(_.isFinite(t)||_.isString(t))&&Qt.getStringOption(e,"authorName","").trim()||"";n&&(pe[t]={id:t,name:n,initials:Qt.getStringOption(e,"initials","").trim()||null,providerId:Qt.getStringOption(e,"providerId","").trim()||null,userId:Qt.getStringOption(e,"userId","").trim()||null})}},this.getRegisteredAuthorItemById=function(e){return pe[e]},this.getAuthorColorIndex=function(e){return Zt.getSchemeColor((t=e,(n=_.indexOf(fe,t))<0&&(n=fe.length,fe.push(t)),n));var t,n},this.addAuthors=function(e){return fe=_.union(fe,e),this},this.stopOperationDistribution=function(e){return Ee=!1,L.convertToPromise(e.call(L)).always(function(){Ee=!0})},this.isOperationsBlockActive=function(){return he},this.enterBlockOperationsMode=function(e){he=!0,vt()&&(L.trigger("docs:operations:remove",i.operations.length),i=Dt(null,i.userData)),e.call(L),he=!1},this.isMultiSelectionApplication=function(){return u},this.isSnapshotApp=function(){return g},this.isFirstTabActivated=function(){return Re},this.getLoadDocInfo=function(){return Pe},this.isOTEnabled=function(){return O},Object.defineProperty(this,"otManager",{get:function(){return t=t||e.createOTManager(this.docModel)},configurable:!0,enumerable:!0}),this.transformPositionWithLocalActions=function(e,t){return this.otManager.transformPosition(e,Fe,t)},this.getOTStatistics=function(){return{extOpCount:ke,otCount:t?t.getStatistics().otCount:0}},this.setOTBlockingOpsMode=function(e){we=e},this.isOTBlockingOpsMode=function(){return we},this.hasLocalActionsWithoutAck=function(){return O&&0<Fe.length},this.getServerOSN=function(){return Le},this.isRescueDocument=function(){return He},this.isRescueDocMode=function(){return gn.DEBUG&&He},this.generateLogData=function(){var e=Fn();if(!e)return"";var t=navigator.userAgent,n=Me,r=Be,i=this.getFullFileName();return t+"\ndoc_uid: "+n+"\nclient_uid: "+r+"\napp: "+this.appType+"\nfileName: "+i+"\n \n"+e},this.useOperationOptimization=function(e){c=e},this.showEditToolbarAtStart=function(){return L.getUserSettingsValue("showToolbars",!0)||_.device("!desktop")},this.debugTypeError=gn.DEBUG?{testPlace:null,activateTestPlace:function(e){this.testPlace=e},test:function(e){this.testPlace===e&&(wn.info("You should see a typeError now at",e),this.debugxyz.debugTypeErrorXYZ())}}:$.noop,(Ne=new Wn(this)).startHook.on(function(){L.trigger("docs:acquireeditrights:start")}),Ne.finishHook.on(function(){L.trigger("docs:acquireeditrights:end")}),Ue=new $n(function(){return kt()?M.syncStable().catch(_.noop):Rn()},{delay:3e4,interval:3e4,windowId:this.getWindowId(),contextMsg:"EditApplication.osnBeacon",background:!0}),this.onInit(function(){U=this.docModel,x=this.docView,this.waitForImport(function(){oe=L.launchTracker.step("triggerImportSuccess","$badge{EditApp} End of import process notified"),De=oe,En.log("Load-mode:",Te)}),je(),Qe(),Ze(),this.listenTo(U,"operations:error",function(){Ve(!1)}),this.on("docs:operations:completed",_t),cn.supportsEditMode(L.appType)||(Ve(!(G=!0)),je(),Ye(cn.DOM_TEXT_EDIT_ALERT,-1)),Y&&Z&&(wn.info("$badge{EditApp} onInit(): saving document to local storage is active"),Un?wn.info("$badge{EditApp} onInit: current browser supports local storage"):wn.warn("$badge{EditApp} onInit: current browser does not support local storage")),this.on("docs:flush:success",function(){o=!1}),U.listenTo(Jt.hideTabHook,function(){Jt.BROWSER_TAB_SUPPORT&&o&&L.flushDocument(Mn.USER),O&&Ue.abort()}),U.listenTo(Jt.showTabHook,function(){O&&Wt()})},this),this.registerBeforeUnloadHandler(function(e){e||xt()}),this.registerUnloadHandler(function(){xt()}),this.registerBeforeQuitHandler(function(){if(gn.DEBUG&&L.debugTypeError.test("sync-beforeQuitHandler"),T)return Rn();var e=L.isOnline()&&L.hasUnsavedFileName()?L.rename(L.getUnsavedFileName()):Rn();return e=(e=e.then(function(){return L.isOnline()?Lt(Mn.QUIT):null})).then(function(){return ht()&&L.hasUnsavedChangesOffice()?x.showQueryDialog(null,_n("This document contains unsaved changes. Do you really want to close?")):void 0})}),this.registerQuitHandler(function(e){function t(){return $.when(be).always(function(){En.log("$badge{EditApp} quitHandler.finalizeRTConnection called"),$t()})}function n(){try{if(En.log("$badge{EditApp} quitHandler.connectionGateKeeper entered"),!kt())return;if(Mt())return;var e=M.getCloseLeaveState();switch(En.log("$badge{EditApp} quitHandler.connectionGateKeeper - connectionOpenState:",e),e){case"unknown":return void Bt();case"closing":case"closed":return void Bt({skipCloseDoc:!0});case"disconnecting":case"disconnected":return;default:return void Bt()}}catch(e){Bt(),wn.warn("$badge{EditApp} quitHandler.connectionGateKeeper: Error caught:",e)}}var r=null;try{En.log("$badge{EditApp} quitHandler: reason",e),gn.DEBUG&&L.debugTypeError.test("sync-quithandler"),r=e===Bn.RELOAD?(Bt(),$.when()):function(e){var t=null,n=L.getWindow(),r=L.getFileDescriptor(),o=!1,i=null,a=["_OSN","_FILEVERSION","_STORAGEVERSION","_OPERATIONS"],s=e===Bn.LOGOUT,l=L.launchTracker;function c(e){o&&x.updateBusyProgress(e)}function O(r){var e="appsuiteDocsExpiryDates",i=localStorage.getItem(e),o=_.now();i&&(i=JSON.parse(i),_.isObject(i)?_.each(i,function(e,n){if(n!==r&&e<o){var t=t||_.pluck(U.getSupportedStorageExtensions({allApps:!0}),"extension").concat(a);_.each(t,function(e){var t=n+e;localStorage.removeItem(t)}),delete i[n]}}):i=null),(i=i||{})[r]=o+6048e5,localStorage.setItem(e,JSON.stringify(i))}function d(){return Xt.propagateChangeFile(r)}n&&n.busy();var u=A||y||D||b,g="new"===w.action||w.template;r&&(u||gn.LOG_PERFORMANCE_DATA||!g&&te.length<=1)&&(i={file:_.extend({last_opened:Date.now()},r),app:L.appType},l.setItem("LocalStorage",J),l.setItem("FastEmptyLoad",ae),l.sendData());var p=kt()&&M.isConnected()&&!L.isShutdownReceived();t=r&&p?(i=ve?i:_.extend({no_restore:ve},i),Jt.BROWSER_TAB_SUPPORT?Ht(e,i).progress(c):Ht(e,i).then(function(c){var d=null,u=null,g=null,p=null,f=null,E=null,e=null,t=A||y||D,n=U.getOperationStateNumber(),h=0,r=20;function i(e){var t=Qt.getBooleanOption(e,"migration",!1);_.each(a,function(e){localStorage.removeItem(u+e)}),t&&(Sn(c.syncInfo.fileVersion)?_.each(_.range(c.syncInfo.fileVersion>r?c.syncInfo.fileVersion-r:0,c.syncInfo.fileVersion),function(t){_.each(a,function(e){localStorage.removeItem(u+"_"+t+e)})}):(localStorage.removeItem(u+"_"+c.syncInfo.fileVersion),localStorage.removeItem(u+"_CURRENTVERSION")))}return ze(),(t||!J)&&c&&c.syncInfo&&!s&&!L.isDocumentEncrypted()&&Un&&Y&&Z&&_.isFunction(U.getFullModelDescription)&&c.syncInfo.fileVersion&&c.syncInfo.fileId&&c.syncInfo.folderId&&Sn(c.syncInfo["document-osn"])&&n===c.syncInfo["document-osn"]&&(O(u=c.syncInfo.fileId+"_"+c.syncInfo.folderId),e=L.newDeferred("EditApplication.saveLocalStorage"),L.executeDelayed(function(){o=!0},"EditApplication.saveFileInStorage",1500),L.executeDelayed(function(){e.notify(.1),d=_.now(),U.getFullModelDescription(e,.1,.9).always(function(){_.isFunction(U.getSupportedStorageExtensions)&&_.each(U.getSupportedStorageExtensions(),function(e){e&&_.isString(e.extension)&&a.push(e.extension)}),i({migration:!0})}).done(function(e){function l(e){return i(),wn.info("$badge{EditApp} quitHandler: "+e),!1}e.every(function(e){var t=e.htmlString,n=u+e.extension,r=null,i=null;wn.info("$badge{EditApp} quitHandler: created document string with size: "+t.length+". Time for conversion: "+(_.now()-d)+" ms.");try{if(0===h){if(g=u+"_OSN",p=u+"_FILEVERSION",f=u+"_STORAGEVERSION",E=u+"_OPERATIONS",localStorage.setItem(g,c.syncInfo["document-osn"]),localStorage.setItem(f,K),localStorage.setItem(p,c.syncInfo.fileVersion),r=U.getStorageOperationCollector(),_.each(r,function(e){delete e.osn,delete e.opl}),i=JSON.stringify(r),localStorage.setItem(E,i),!localStorage.getItem(E)||localStorage.getItem(E).length!==i.length)return l("failed to save document operations in local storage");wn.info("$badge{EditApp} quitHandler: successfully saved document operations in local storage with key: "+E)}localStorage.setItem(n,t);var o=localStorage.getItem(n);if(!o||o.length!==t.length)return l("failed to save document in local storage");if(wn.info("$badge{EditApp} quitHandler: successfully saved document in local storage with key: "+n),0===h){var a=localStorage.getItem(g),s=a?parseInt(a,10):-1;if(s!==c.syncInfo["document-osn"])return l("failed to save OSN for document in local storage");wn.info("$badge{EditApp} quitHandler: successfully saved OSN for document in local storage with key: "+g+" : "+s)}return h++,!0}catch(e){return l("failed to save document and/or document OSN in local storage")}})}).always(function(){e.notify(1),e.resolve(c)})},"EditApplication.saveFileInStorage")),null===e?c:e.promise()}).progress(c)):$.when();p&&(t=t.then(function(){return gn.DEBUG&&L.debugTypeError.test("async-quithandler"),Pt(".disconnect",null,2e3)}));r&&(u?t=t.then(d,d):"reload"!==e&&("new"===w.action||w.template)&&te.length<=1&&!w.keepFile&&(t=t.then(function(){return Xt.purgeFile(r)})));return t}(e)}catch(e){r=$.when(),wn.warn("$badge{EditApp} quitHander: Error caught:",e)}return r=(r=r.then(n,n)).then(t,t)}),this.waitForImportStart(function(){ln.logState("import","app/loading","pending")}),this.once("docs:state:preview",function(){ln.logState("import","app/preview","pending")}),this.waitForImport(function(){ln.logState("import","app/preview","resolved"),ln.logState("import","app/loading","resolved")}),this.waitForImportSuccess(function(){O&&Wt()}),this.registerDestructor(function(){Ue.destroy(),Ne.destroy(),w=F=L=U=x=null,M=p=i=Oe=null,B=H=null,f=E=s=null,l=h=null,v=X=te=ne=null,re=Ue=null,Ne=Ae=null})})});